package com.despark.tuning3d.controller
{
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.view.WindowMediator;
import com.despark.tuning3d.view.components.tunings.TuningsListScreen;


import org.puremvc.as3.interfaces.INotification;
import org.puremvc.as3.patterns.command.SimpleCommand;

public class DisplayTuningsListScreenCommand extends DisplayScreenCommand
{
    override public function execute(note : INotification) : void
    {
        executeHandler = function ():void {
            var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
            assetsProxy.loadBrandScreenAssets(false);
            assetsProxy.loadFeedAssets(true, function () : void {
                var windowMediator : WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                var garageScreen : TuningsListScreen = new TuningsListScreen();

                if(note.getBody() && note.getBody().hasOwnProperty("deleteOtherScreens") && note.getBody().deleteOtherScreens == true) {
                    windowMediator.pushScreen(garageScreen, true, false);// do not delete the previous screen
                    garageScreen.enableBackward = true;
                    garageScreen.activateCloseButton();
                } else {
                    windowMediator.pushScreen(garageScreen);
                    if(note.getBody() && note.getBody().hasOwnProperty("enableCloseButton") && note.getBody().enableCloseButton == true){
                        garageScreen.enableBackward = true;
                        garageScreen.activateCloseButton(note.getBody().closeHandler);
                    }
                }
            });
        };
        super.execute(note);

    }
}
}