package com.despark.tuning3d.view.components.tunings.editing
{
import com.utils.FontSelector;

import feathers.controls.Label;
import feathers.core.FeathersControl;

import flash.geom.Rectangle;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.animation.Transitions;
import starling.animation.Tween;
import starling.core.Starling;
import starling.display.Image;
import starling.textures.Texture;
import starling.utils.AssetManager;

public class TuningProgressBar extends FeathersControl
	{
		public var assetManager : AssetManager;
		
		private var _progress : Number = -1;
		private var backgroundImage:Image;
		private var progressImage:Image;
		private var texture : Texture;
		private var percentDisplay:Label;
		
		
		public function TuningProgressBar()
		{
			super();
			visible = false;
		}
		
		public function get progress() : Number
		{
			return _progress;
		}

		public function set progress(value : Number):void
		{
			_progress = value;
			invalidate("progress");
		}

		override protected function initialize() : void
		{
			super.initialize();
			
		
			
			texture = assetManager.getTexture("roundRect");
			//var textures : Scale3Textures = new Scale3Textures(texture, 3, 4, Scale3Textures.DIRECTION_HORIZONTAL);
			
			backgroundImage = new Image(texture);
			backgroundImage.scale9Grid = new Rectangle(3,0,4,texture.frameHeight);
			
			
			backgroundImage.alpha = 0.3;
			addChild(backgroundImage);
			
			progressImage = new Image(texture);
			
			progressImage.scale9Grid = new Rectangle(3,0,4,texture.frameHeight);
			
			
			addChild(progressImage);
			
			/*percentDisplay=new Label();
			
			
			percentDisplay.textRendererFactory=function():Object
			{
				var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
				
				textRenderer.textFormat = getCarCountTextFieldTextFormat() as TextFormat;
				textRenderer.embedFonts = FontSelector.embedFonts();
				//smoothing=TextureSmoothing.TRILINEAR;
				textRenderer.snapToPixels=false;
				
				return textRenderer;
			}*/
			
			//addChild(percentDisplay);
			//progressImage.color = 0xed1c24;
			
			setSizeInternal(100, texture.height, false);
		}
		
		public function getCarCountTextFieldTextFormat() : TextFormat
		{
			
			var fontName:String=FontSelector.getFont(true);
			
			var textFormat : TextFormat = new TextFormat(FontSelector.getFont(), 7, 0xffffff);
			textFormat.align = TextFormatAlign.RIGHT;
			textFormat.bold=true;    
			
			return textFormat;
		}
		
		override protected function draw() : void
		{
			super.draw();
			
			
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				backgroundImage.width = actualWidth;
				backgroundImage.height = actualHeight;
				
				progressImage.height = backgroundImage.height;
				
				//percentDisplay.width=actualWidth;
				//percentDisplay.height=9;
				
				//percentDisplay.y=backgroundImage.height+2;
				
			}
			
			if(isInvalid("progress") && progress >= 0)
			{
				progressImage.width = Math.max(progress * backgroundImage.width, texture.width);
				
				
				alpha = 1.0;
				
				//percentDisplay.text=(progress*100)+" %";
				
				if(progress == 1)
				{
					var tween : Tween = new Tween(this, 0.3, Transitions.EASE_OUT);
					tween.delay = 0.5;
					tween.fadeTo(0);
					tween.onComplete = function() : void
					{
							visible = false;
					}
					Starling.juggler.add(tween);		
				}
			}
		}
	}
}