package com.utils {
public class RegExpUtil {
    private static const URL_REGEXP:RegExp = /(http(s)?:\/\/((\d+\.\d+\.\d+\.\d+)|(([\w-]+\.)+([a-z,A-Z][\w-]*)))(:[1-9][0-9]*)?(\/([\w-.\/:%+@&=]+[\w- .\/?:%+@&=]*)?)?(#(.*))?)/ig;
    private static const DOMAIN_REGEXP:RegExp = /[^https:\/\/]([a-z-_]*)?.?[a-z-_]*.[a-z]*/;
    private static const IMAGE_REGEXP:RegExp = /(jpg|jpeg|png)$/img;
    public static function urlsToAnchors(str:String):String{
        return str.replace(URL_REGEXP, "<font color='#ED9564'><a href='$1'><b>$1</b></a></font>");
    }

    public static function getDomain(str:String):String{
        return str.match(DOMAIN_REGEXP)[0];
    }

    public static function removeHtmlTags(str:String):String{
        var patter:RegExp = /<[^>]*>/gsmi;
        return str.replace(patter, '');
    }

    public static function getHtmlTagContent(str:String, tagName:String):String{
        var patter:RegExp = new RegExp("<"+tagName+">(?P<content>.*)</"+tagName+">", 'gsmi');
        var result:Object = patter.exec(str);
        if(result && result.content){
            return result.content;
        }
        return null;
    }

    public static function isAllowedImageURL(str:String):Boolean{
        return IMAGE_REGEXP.test(str);
    }
}
}
